from base64 import b64encode, b64decode
from hashlib import sha1

def encrypt(text):
    if isinstance(text, str):
        text = text.encode('utf-8')
    encoded = b64encode(text).decode('utf-8')
    encoded_no_padding = encoded.rstrip('=')
    return '!!!' + ''.join(char for char in reversed(encoded_no_padding))

def decrypt(encrypted_text):
    if isinstance(encrypted_text, bytes):
        encrypted_text = encrypted_text.decode('utf-8')
    encrypted_text = encrypted_text.replace('!!!', '')
    encoded_no_padding = ''.join(char for char in reversed(encrypted_text))
    encoded = encoded_no_padding + '=' * (len(encoded_no_padding) % 4)
    return b64decode(encoded.encode('utf-8')).decode('utf-8')

def is_encrypted_password(password):
    return password.startswith('!!!')

def encrypt_password(password):
    if is_encrypted_password(password):
        return password
    return encrypt(password)

def decrypt_password(password):
    if not is_encrypted_password(password):
        return password
    return decrypt(password)
